Page MenuHomePhabricator

MediaWiki Developer Summit 2015 proposal: Performance and profiling
Closed, ResolvedPublic

Description

Share tips and tricks for profiling (e.g. xhprof) and discuss about performance, especially as concerns Wikidata.

Topics covered: forceprofile, xenon, memcached (no good data yet for it), event logging and demonstrated using xdebug / cachegrind to find specific performance issues to fix.

Event Timeline

aude created this task.Jan 9 2015, 5:58 PM
aude claimed this task.
aude raised the priority of this task from to Needs Triage.
aude updated the task description. (Show Details)
aude added subscribers: aude, daniel, hoo.
Qgil triaged this task as Medium priority.Jan 12 2015, 7:58 PM
Qgil added a subscriber: Qgil.Jan 27 2015, 7:04 AM

Please update the description with the achievements of this session. Thank you in advance.

aude updated the task description. (Show Details)Jan 30 2015, 10:49 PM
aude set Security to None.
aude added a comment.Feb 23 2015, 3:07 PM

Notes from the session:

forceprofile

forceprofile=1 now requires passing a special header “X-Wikimedia-Debug” and uses xhprof in the background. No need now for using wfProfileIn / Out.

https://github.com/bd808/FirefoxWikimediaDebug / https://addons.mozilla.org/en-US/firefox/addon/wikimedia-debug-header/ - firefox plugin for adding the header

https://chrome.google.com/webstore/detail/wikimediadebug/binmakecefompkjggiklgjenddjoifbb

xenon

production profiling data:

http://performance.wikimedia.org/xenon/ - collects samples from production traces

memcached

not very good statistics and data now, except overall load. (wikidata is significant, so can still tell some stuff from this)

event logging

might be able to use event logging to collect some more data about memcached usage of sites or other stuff (e.g. cache misses).

event logging can also be used for non-creepy stuff :) like collecting some stats on errors users encounter (in js / from api) when saving an item, etc. WikiGrok is using event logging for this sort of thing currently.

Wikidata team should at least experiment with setting up event logging to get better memcached usage information.

https://www.mediawiki.org/wiki/Extension:EventLogging

event logging data is collected and available in graphite and there also is a dashboard (with limn), and we (NDA folks) can get access to the analytics servers and databases.

logstash might also have more potential for visualizing and monitoring performance and event logging.

Links

Profiling

http://performance.wikimedia.org/xenon/svgs/daily/2015-01-27.svgz

Performance

aude closed this task as Resolved.Feb 23 2015, 3:08 PM
aude updated the task description. (Show Details)